## 目标
- **了解自主导航的实现方法**
- **用实验五里建好的地图，实现自主导航功能**

## 内容
### 1、机器人自主导航的实现
首先确保机器人已经回到实验二中设定的起点，锁定机器人遥控器。在香橙派终端打开navigation文件夹，同样可以输入
>ls

查看navigation文件夹下的文件。

![](/uploads/rem/images/m_c8a0dae8ba848cb072dc8dcff5f22283_r.png "图6.1 navigation文件夹下目录")

依次运行run_navi.sh、start_mavros.sh和set_ekf_origin.sh脚本，并依次检查弹终端窗口，检查每个终端中的节点是否正常启动。

输入
>./run_navi.sh

启动重定位和导航算法。

![](/uploads/rem/images/m_ed4bbcbd4bc7b25ec80a1a20cc02afb5_r.png "图6.2 运行run_navi.sh脚本")

输入
>./start_mavros.sh

启动飞行控制单元。飞控部分负责处理传感器数据，计算机器人的姿态和位置，并生成控制信号来调整执行器的动作，从而实现对机器人的控制。

![](/uploads/rem/images/m_078e1d6ded8aefb9c39075c8746e8059_r.png "图6.3 运行start_mavros.sh脚本")

输入
>./set_ekf_origin.sh

为机器人设置原点，为了与实验二的建图保持一致，选取大黑楼的地理坐标为原点。

![](/uploads/rem/images/m_53ce9c7391d215b6f2be7522cd51d8ee_r.png "图5.4 运行set_ekf_origin.sh脚本")

将遥控器右上方拨杆拨到左端的自动模式，机器人会按照实验二中建好的地图运动。由于纯跟踪轨迹跟踪控制算法的设定，可以选择两种运动模式。

第一，执行避障功能。进入pure_persuit文件夹下的launch文件夹，打开pure_persuit.py文件，修改避障函数is_avoid_obstacle中的参数为true，并同时修改local_planner文件夹下的local_planner.py文件，同样修改避障函数is_avoid_obstacle中的参数为true。在完成以上两处修改后，机器人在进行导航运动时将执行避障功能。执行避障功能时，当机器人前方出现障碍物，机器人将自动绕过障碍物并重新回到原路线继续行驶。

[视频演示](https://v.qq.com/x/page/p3560v3rm4v.html)

第二，不执行避障功能。当pure_persuit.py和local_planner.py文件中函数is_avoid_obstacle的参数均设置为为false时，机器人在进行导航运动时不执行避障功能。机器人运动的过程中， 每前进五米就会暂停五秒。当机器人前方出现障碍物时，机器人会停止前进，障碍物消失后，机器人继续按照地图运动。

[视频演示](https://v.qq.com/x/page/f3560z9k0jt.html)

当机器人返回起点，停止运动，可以在终端输入输入
>./kill.sh

关闭全部进程。

### 2、rviz可视化结果

导航结束后，会自动生成俩个文件夹，分别保存里程计的数据和实验数据。进入navigation文件夹，进入data文件夹下的bags文件夹，输入
>ls

可以查看当前文件夹下保存的包名。这里将存放里程计数据的包命名为navigation01，将存放实验数据的包命名为navigation02。

首先查看里程计数据的可视化结果。打开香橙派终端，输入
>rviz2

进入rviz可视化界面。

在bags文件夹下打开终端，输入
>ros2 bag play navigation01/

将navigation01包中的消息载入到rviz中。

在rviz界面中，点击Add——By topic—— 选择里程计数据话题 —— 点击OK。

![](/uploads/rem/images/m_5d28c0903eb59bfde61f4119183f79d3_r.png "图6.5 rviz界面操作")

将rviz中的Fixed_Frame参数修改为odom。将shape参数修改为Axes显示坐标系。将keep参数修改为100000显示机器人运动的整个轨迹。

![](/uploads/rem/images/m_879693bb041758dd5d4e8bf598dd6243_r.png "图6.6 显示运动轨迹操作")

等待一段时间后，可以显示机器人导航运动的完整轨迹。这里显示的是在避障模式下机器人的轨迹，从图中可以看到机器人的轨迹出现一定的弯曲，表示在该位置机器人绕过障碍物并返回原路线。

![](/uploads/rem/images/m_9201d0fc782af21296cf53b7e88e8c45_r.png "图6.7 机器人运动轨迹")

接着查看导航实验数据的可视化结果。打开终端，输入
>./run_navi_replay.sh

运行脚本，rviz窗口会自动弹出。

进入navigation文件夹，进入data文件夹下的bags文件夹，在bags文件夹下打开一个新的终端，输入
>ros2 bag play navigation02/

将navigation02包中的消息载入到rviz中。这时可以看到rviz界面中出现一条蓝色的线，这条线代表建图过程录入的机器人的轨迹。

![](/uploads/rem/images/m_518782497f59d3bed8f510b0e1b79318_r.png "图6.8 机器人导航运动参考轨迹")

机器人前方的白线代表机器人可以选择的运动轨迹，当前方蓝色的轨迹上出现障碍物，机器人可以选择白线的轨迹进行避障。

![](/uploads/rem/images/m_0e597e5ce630a8f450221d1f6b72d6ff_r.png "图6.9 机器人避障轨迹")

图中的红线代表机器人的实际运动轨迹，由可视化结果可以看出，机器人的实际运动轨迹与设定的轨迹基本相符。

![](/uploads/rem/images/m_9092449431e46cfdb5a985e8dc004898_r.png "
图6.10 机器人实际运动轨迹")