##  1.1 配件介绍
实验机器人是一款名为iM4WD的全向全驱麦克纳姆轮无人车。

![](/uploads/rem/images/m_63b023236fdd70738cd45e8af0cc0fec_r.png "图1.1 iM4WD全向全驱麦克纳姆轮无人车")

该车的主要配件和性能参数如下。

##  1.2 麦克纳姆轮车原理
### 1.2.1 实验目标
- 了解麦克纳姆轮的运动原理
- 了解麦克纳姆轮能够实现的运动效果

### 1.2.2 实验内容
图1.2中所示的是本实验搭建的全向移动机器人所使用的全向轮，麦克纳姆轮（Mecanum）。它是由瑞典Mecanum AB公司的工程师Bengt Ilon在1973年所设计开发的，因此也被称作瑞典轮或Ilon轮，自问世以来便受到工业领域的热衷。麦克纳姆轮的典型结构是轮毂表面排布一定数量的辊子，其中辊子通常是外形为椭圆弧的圆柱面，多为橡胶材质，可自由滚动，排列方式为与轮毂轴呈45°夹角。

![](/uploads/rem/images/m_8ff630eb10d801da66ec6702c9c5fdef_r.png "图1.2 麦克纳姆轮")

本实验机器人选用的麦克纳姆轮是WHEELTEC公司抱紧式联轴器麦克纳姆轮，规格参数如下：

| 名称  | 参数  | 名称  | 参数  |
| ------------ | ------------ | ------------ | ------------ |
| 辊子个数  | 16个  | 轮宽  | 45mm  |
| 辊子材质  | 橡胶  | 直径  | 152mm  |
| 辊子排列方式  | 45°  | 单轮重量  | 2.85kg  |
| 辊子直径  | 3mm  | 单轮承重  | 25kg  |
| 轮毂材质  | 不锈钢（表面电镀）  | 安装孔径  | 12mm  |

在典型的麦克纳姆轮中，辊子通常以与轮毂轴线呈45°夹角的方式安装在轮毂面上。这种特殊的结构也造就了麦克纳姆轮独特的受力分解方式，也是基于麦克纳姆轮的移动机器人能够实现全向移动的结构基础。

![](/uploads/rem/images/m_154fac752344d52cb25541ee61eafa6a_r.png "图1.3 (a) 麦克纳姆轮受力分解；(b) Fr、Fh 产生的速度；(c) 轮毂速度分解")

麦克纳姆轮的受力分解如图1.3(a)所示，其中矩形表示轮毂，斜线表示安装在轮毂表面的辊子。在机器人运动过程中，辊子与地面直接接触，接触点受力作用，由于辊子的特性，作用力被分解为垂直于辊子轴线的力和平行于辊子轴线的力。垂直于辊子的产生使辊子转动的速度，平行于辊子轴线的力产生驱动轮毂转动的速度，如图1.3(b)所示。由于主要驱动辊子发生转动，对移动机器人的实际速度的作用微乎其微，因此移动机器人的实际运动速度主要是由产生的。因为辊子以与轮毂轴线 45°夹角的方式排布在轮毂面上，所以可以对速度进行正交分解，如图1.3(c)所示，令垂直于轮毂轴线的速度分量为，平行于轮毂轴线的速度分量为。由麦克纳姆轮的运动特性可知，多个麦克纳姆轮通过不同的布局方式，可以得到不同的运动效果，通常，基于四个麦克纳姆轮的全向移动机器人有两种排布方式，“X”型排布和“O”型排布，如图1.4所示。

![](/uploads/rem/images/m_0e29a6d1c368cc28519bf7ba0a844e5d_r.png "图1.4 (a) 麦克纳姆轮底盘“O”型布局；(b) 麦克纳姆轮底盘“X”型布局")

本实验搭建的平台选择“X”型排列进行布局。由前面的对麦克纳姆轮的运动原理的分析可得，基于麦克纳姆轮的全向移动机器人的运动速度是由车身上轮子的速度通过矢量合成而来的，因此通过驱动电机速度不同的转速，可以使运动底盘实现不同的运动效果，理论上可以实现的基本的八种运动效果如图1.5所示，其中黑色箭头表示轮子的运动方向，红色箭头表示整车运动方向。

![](/uploads/rem/images/m_42d65e291a5fee6efd2c7f402e4e242a_r.png "图1.5 麦克纳姆轮底盘基本运动效果")

接下来进行机器人遥控实操。本实验机器人使用的遥控器如图1.6所示。

![](/uploads/rem/images/m_ed49a97caee62fb1370ba1e529c5e184_r.png "图1.6 遥控器示意图")

首先启动遥控器，先短按后长按电源开关至遥控器的指示灯全部亮起，遥控器开启时有蜂鸣器提示音。遥控器启动后，拨动遥控器左上方的拨杆至最右端解锁遥控器，遥控器右上方拨杆保持在最右端的手动模式，就可以手动遥控机器人进行全向运动。遥控器摇杆使用方法如下：

| 摇杆  | 功能  |
| :------------: | :------------: |
| 左摇杆向上推动  | 机器人前进  |
| 左摇杆向下推动  | 机器人后退  |
| 左摇杆向左推动  | 机器人向左横移  |
| 左摇杆向右推动  | 机器人向右横移  |
| 右摇杆向左推动  | 机器人左转  |
| 右摇杆向右推动  | 机器人右转  |

机器人遥控演示效果如下：
- 前进后退

![](/uploads/rem/images/m_3b447d96e73b644be8deac59adf3c595_r.png)

- 左右横移

![](/uploads/rem/images/m_7355ad033a6ee03620a2dbcc6147a1f5_r.png)

- 左转右转

![](/uploads/rem/images/m_cd0886d1b992e7d7eaba8c9275c35cd8_r.png)