## 目标
- **了解如何使用激光里程计和Mavros在ROS2中进行定位**

## 内容
### 1、搭建环境
- 安装ROS2。
- 安装Mavros和Cartographer包。
- 准备激光雷达传感器和飞控设备，确保其可以与电脑进行通信。

### 2、参数设置
修改Cartographer配置文件，设置激光里程计相关参数。设置AHRS_GPS_USE=0关闭GPS使用。

![](/uploads/rem/images/m_5e239c402a368cd1599fd1ac4cbc2c5a_r.png)

3、启动SLAM
将SLAM的里程计输出话题重映射为/mavros/vision_pose/pose，然后开启mavros后可以观察到以下信息输出，表示飞控已经接收到了里程计消息。

![](/uploads/rem/images/m_0d83cc6628aa42ff069ef09012404c60_r.png "图2.3 输出信息")

设置EKF原点，以启动EKF算法，将里程计数据与IMU数据进行融合。通过输入命令
>ros2 topic pub

发送虚假GPS消息，或者通过Mission Planner在地图中右击选择“set EKF Origin”，设置EKF原点。

输入命令
>ros2 topic pub

命令发送Twist速度消息到/mavros/setpoint_velocity/cmd_vel_unstamped话题，观察机器人是否能够根据指令进行移动。